SystemOrganization addCategory: #DiagramBrowser!

Model subclass: #DiagramOrganizationBrowser
	instanceVariableNames: 'selectedSuborganization selectedDiagramIndex dependencedDiagrams suborganizationsListMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiagramBrowser'!

!DiagramOrganizationBrowser commentStamp: 'hpt 7/24/2004 14:27' prior: 0!
DiagramOrganizationBrowser is the tool for building and browsing instances of DiagramOrganizations, the categories that holds the instances of Diagram.!

!DiagramOrganizationBrowser methodsFor: 'accessing' stamp: 'hpt 1/15/2003 19:54'!
selectedDiagramIndex: anIndex
	selectedDiagramIndex := anIndex.
	self changed: #selectedDiagramIndex.
	self changed: #selectedDiagram.! !

!DiagramOrganizationBrowser methodsFor: 'addings/removals' stamp: 'hpt 1/15/2003 19:59'!
moveSelectedSuborganizationTo: destination
	| selected |
	selected := self selectedSuborganization.
	self removeSelectedSuborganization.
	destination addSuborganization: selected.
	self selectedSuborganization: destination.
	self changed: #hierarchicalListItemWrapper.! !

!DiagramOrganizationBrowser methodsFor: 'updating' stamp: 'hpt 3/22/2003 16:56'!
update: aSymbol
	aSymbol == #title
		ifTrue: [self changed: #selectedSuborganizationDiagramTitles].! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 3/22/2003 16:56'!
addNewDiagram
	| aTitle aDiagram |
	aTitle := FillInTheBlank request: 'new diagram title?'.
	aTitle isEmpty 
		ifTrue: [^self].
	aDiagram := Diagram new.
	aDiagram title: aTitle.
	self selectedSuborganization addDiagram: aDiagram.
	self changed: #selectedSuborganizationDiagramTitles.
	self selectedDiagram: aDiagram.! !

!DiagramOrganizationBrowser methodsFor: 'queries' stamp: 'hpt 1/15/2003 20:47'!
unselectSelectedSuborganization
	"I don't want to have no organization selected, so to unselect a suborganization I simply select the root organization"
	self selectedSuborganization: self diagramOrganization.! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 1/15/2003 20:00'!
confirmSelectedSuborganizationRemoval
	(self selectedSuborganization = self) | (self selectedSuborganization = nil)
		ifTrue: [^self].
	(self confirm: 'Are you certain that you
want to REMOVE the suborganization ', self selectedSuborganization name, '
with all of its diagrams and suborganizations from the system?')
		ifTrue: [self removeSelectedSuborganization].! !

!DiagramOrganizationBrowser methodsFor: 'accessing' stamp: 'hpt 3/22/2003 16:56'!
selectedSuborganization: aDiagramsOrganizationOrNil
	selectedSuborganization = aDiagramsOrganizationOrNil
		ifTrue: [^self].
	aDiagramsOrganizationOrNil
		ifNil: [^self].
	selectedSuborganization := aDiagramsOrganizationOrNil.
	self changed: #selectedSuborganization.
	self changed: #selectedSuborganizationDiagramTitles.
	self unselectSelectedDiagram.
! !

!DiagramOrganizationBrowser methodsFor: 'queries' stamp: 'hpt 3/22/2003 16:56'!
indexOfDiagram: aDiagram
	| index |
	index := 0.
	self selectedSuborganizationDiagramTitles do: [:aTitle | 
		index := index + 1.
		aTitle = aDiagram title
			ifTrue: [^index]].
	^index.! !

!DiagramOrganizationBrowser methodsFor: 'queries' stamp: 'hpt 1/15/2003 19:55'!
selectNoneOrFirstDiagram
	self selectedSuborganizationDiagrams isEmpty
		ifTrue: [self selectedDiagramIndex: 0]
		ifFalse: [self selectedDiagramIndex: 1].

! !

!DiagramOrganizationBrowser methodsFor: 'creation' stamp: 'hpt 1/15/2003 19:49'!
asMorph
	^(Morph new)
		layoutPolicy: (ProportionalLayout new);
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: (self preferredExtent);
		color: (self preferredColor);
		addMorph: (self newOrganizationsList) fullFrame: (self organizationsListFrame);
		addMorph: (self newDiagramsList) fullFrame: (self diagramsListFrame);
		yourself.! !

!DiagramOrganizationBrowser methodsFor: 'save on/load from file' stamp: 'hpt 3/26/2003 22:32'!
addDiagramFromFile
	| aDiagram |
	aDiagram _ self selectedSuborganization addDiagramFromFile.
	aDiagram notNil
		ifTrue: [
			self changed: #selectedSuborganizationDiagramTitles.
			self selectedDiagram: aDiagram].! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 4/12/2003 16:30'!
addSuborganizationMenuOptionsTo: aMenu
	aMenu 
		add: 'add new suborganization' action: #addNewSuborganization;
		add: 'file-in' action: #addSuborganizationFromFile;
		add: 'file-out' action: #saveSelectedSuborganizationToFile.
	(self selectedSuborganization ~= self diagramOrganization) & 
		(self selectedSuborganization notNil) ifTrue:
		[aMenu
			add: 'remove' action: #confirmSelectedSuborganizationRemoval;
			add: 'move' action: #moveSelectedSuborganization;
			add: 'change name' action: #renameSelectedSuborganization].
	^aMenu.! !

!DiagramOrganizationBrowser methodsFor: 'save on/load from file' stamp: 'hpt 3/26/2003 22:34'!
addSuborganizationFromFile
	| anOrganization |
	anOrganization _ self selectedSuborganization addSuborganizationFromFile.
	anOrganization ifNotNil: [self changed: #hierarchicalListItemWrapper].! !

!DiagramOrganizationBrowser methodsFor: 'accessing' stamp: 'hpt 4/11/2003 22:19'!
suborganizationsListMorph
	^suborganizationsListMorph! !

!DiagramOrganizationBrowser methodsFor: 'accessing' stamp: 'hpt 3/1/2003 17:10'!
diagramOrganization
	^self defaultDiagramOrganization.
! !

!DiagramOrganizationBrowser methodsFor: 'addings/removals' stamp: 'hpt 1/15/2003 19:59'!
removeSelectedSuborganization
	| suborganizationToRemove parent |
	suborganizationToRemove := self selectedSuborganization.
	parent := self selectedSuborganizationParent.
	self selectedSuborganization: parent.
	parent removeSuborganization: suborganizationToRemove.
	self changed: #hierarchicalListItemWrapper.! !

!DiagramOrganizationBrowser methodsFor: 'morphic view' stamp: 'hpt 1/15/2003 19:50'!
diagramsListFrame
	^LayoutFrame fractions: (0@0.4 corner: 1@1).! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 4/12/2003 16:30'!
addDiagramMenuOptionsTo: aMenu
	aMenu 
		add: 'add new diagram'
			action: #addNewDiagram;
		add: 'file-in'
			target: self
			selector: #addDiagramFromFile.
	self selectedDiagram ifNotNil: 
		[aMenu 
			add: 'remove'
				action: #confirmSelectedDiagramRemoval;
			add: 'move diagram'
				action: #moveSelectedDiagram;
			add: 'add copy'
				action: #addCopyOfDiagram.
		self selectedDiagram addMenuOptionsTo: aMenu].
	^aMenu.! !

!DiagramOrganizationBrowser methodsFor: 'updating' stamp: 'hpt 1/15/2003 19:58'!
addDependenceOnDiagram: aDiagram
	aDiagram addDependent: self.
	dependencedDiagrams add: aDiagram.! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 3/26/2003 20:18'!
diagramsListMenu: aMenu
	aMenu defaultTarget: self.
	self selectedDiagram notNil
		ifTrue: [aMenu addTitle: 'Diagram ', self selectedDiagram title]
		ifFalse: [aMenu addTitle: 'Diagrams'].
	self addDiagramMenuOptionsTo: aMenu.
	^aMenu.! !

!DiagramOrganizationBrowser methodsFor: 'save on/load from file' stamp: 'hpt 3/22/2003 17:03'!
saveSelectedSuborganizationToFile
	self selectedSuborganization saveToFile.! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 3/7/2003 23:56'!
renameSelectedSuborganization
	| aName |
	aName := FillInTheBlank 
		request: 'new suborganization name?'
		initialAnswer: self selectedSuborganization name.
	aName isEmpty
		ifFalse: [self selectedSuborganization name: aName].
	self changed: #hierarchicalListItemWrapper.! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 4/11/2003 22:20'!
addNewSuborganization
	| aName anOrganization |
	aName := FillInTheBlank request: 'new suborganization name?'.
	aName isEmpty 
		ifTrue: [^self].
	anOrganization := DiagramOrganization new.
	anOrganization name: aName.
	self selectedSuborganization addSuborganization: anOrganization.
	self suborganizationsListMorph expandAll.
	self selectedSuborganization: anOrganization.
	self changed: #hierarchicalListItemWrapper.
	self askForAddingANewDiagram.! !

!DiagramOrganizationBrowser methodsFor: 'morphic view' stamp: 'hpt 1/15/2003 19:50'!
preferredColor
	^Color white! !

!DiagramOrganizationBrowser methodsFor: 'morphic view' stamp: 'hpt 4/11/2003 22:17'!
newOrganizationsList
	suborganizationsListMorph := SimpleHierarchicalListMorph
		on: self
		list: #hierarchicalListItemWrapper
		selected: #selectedSuborganization
		changeSelected: #selectedSuborganizationWrapper:
		menu: #organizationsListMenu:
		keystroke: nil.
	^suborganizationsListMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself.! !

!DiagramOrganizationBrowser methodsFor: 'accessing' stamp: 'hpt 1/15/2003 19:54'!
selectedDiagramIndex
	^selectedDiagramIndex! !

!DiagramOrganizationBrowser methodsFor: 'morphic view' stamp: 'hpt 3/26/2003 20:08'!
newDiagramsList
	| list |
	list := PluggableListMorph 
		on: self 
		list: #selectedSuborganizationDiagramTitles
		selected: #selectedDiagramIndex 
		changeSelected: #selectedDiagramIndex:
		menu: #diagramsListMenu:.
	^list
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself.! !

!DiagramOrganizationBrowser methodsFor: 'morphic view' stamp: 'hpt 4/11/2003 22:15'!
selectedSuborganizationWrapper: aDiagramsOrganizationWrapper
	self selectedSuborganization: aDiagramsOrganizationWrapper withoutListWrapper.
! !

!DiagramOrganizationBrowser class methodsFor: 'instance creation' stamp: 'hpt 1/15/2003 20:21'!
new
	^(super new)
		initialize;
		yourself.! !

!DiagramOrganizationBrowser methodsFor: 'queries' stamp: 'hpt 1/15/2003 19:56'!
selectedSuborganizationDiagrams
	^self selectedSuborganization diagrams! !

!DiagramOrganizationBrowser methodsFor: 'queries' stamp: 'hpt 1/15/2003 20:31'!
selectedSuborganizationParent
	^self diagramOrganization parentOrganizationOf: self selectedSuborganization.! !

!DiagramOrganizationBrowser methodsFor: 'initialize' stamp: 'hpt 3/1/2003 17:10'!
defaultDiagramOrganization
	^JacarandaRootOrganization uniqueInstance! !

!DiagramOrganizationBrowser methodsFor: 'queries' stamp: 'hpt 1/15/2003 19:55'!
selectedDiagram
	(self selectedDiagramIndex < 1) | (self selectedDiagramIndex > self selectedSuborganizationDiagrams size)
		ifTrue: [^nil]
		ifFalse: [^(self selectedSuborganizationDiagrams) at: self selectedDiagramIndex]! !

!DiagramOrganizationBrowser methodsFor: 'updating' stamp: 'hpt 1/15/2003 19:58'!
removeDependencesOnDiagrams
	dependencedDiagrams do: [:ea | ea removeDependent: self].
	dependencedDiagrams := OrderedCollection new.! !

!DiagramOrganizationBrowser methodsFor: 'queries' stamp: 'hpt 3/22/2003 16:56'!
selectedSuborganizationDiagramTitles
	self updateDependencedDiagrams.   "<- with this I ensure I allways 
	                                                           will have a dependence on the 
	                                                           diagrams showing in the list"
	^self selectedSuborganizationDiagrams collect: [:ea | ea title].! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 4/11/2003 21:46'!
askForAddingANewDiagram
	(self confirm: 'Do you wan''t to add a new diagram in this suborganization')
		ifTrue: [self addNewDiagram].
! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 1/15/2003 20:30'!
menuOfAllOrganizationsWithTarget: target selector: aSelector
	^self diagramOrganization menuOfAllOrganizationsWithTarget: target selector: aSelector.! !

!DiagramOrganizationBrowser methodsFor: 'queries' stamp: 'hpt 1/15/2003 19:56'!
selectedDiagram: aDiagram.
	self selectedDiagramIndex: (self indexOfDiagram: aDiagram).! !

!DiagramOrganizationBrowser methodsFor: 'morphic view' stamp: 'hpt 1/15/2003 19:50'!
organizationsListFrame
	^LayoutFrame fractions: (0@0 corner: 1@0.4).! !

!DiagramOrganizationBrowser methodsFor: 'accessing' stamp: 'hpt 1/15/2003 19:53'!
selectedSuborganization
	^selectedSuborganization! !

!DiagramOrganizationBrowser methodsFor: 'addings/removals' stamp: 'hpt 3/22/2003 16:56'!
removeSelectedDiagram
	| diagramToRemove |
	diagramToRemove := self selectedDiagram.
	self unselectSelectedDiagram.
	self selectedSuborganization removeDiagram: diagramToRemove.
	self changed: #selectedSuborganizationDiagramTitles.! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 1/15/2003 20:00'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If can respond, then perform it on myself.  If not, send it to otherTarget, presumably the editPane from which the menu was invoked." 

	(self respondsTo: selector)
		ifTrue: [^self perform: selector]
		ifFalse: [^otherTarget perform: selector].! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 1/15/2003 20:00'!
confirmSelectedDiagramRemoval
	self selectedDiagram 
		ifNil: [^self].
	(self confirm: 'Are you certain that you
want to REMOVE the diagram ', self selectedDiagram title, '
from the system?')
		ifTrue: [self removeSelectedDiagram].! !

!DiagramOrganizationBrowser methodsFor: 'initialize' stamp: 'hpt 3/1/2003 17:11'!
initialize
	selectedDiagramIndex := 0.
	dependencedDiagrams := OrderedCollection new.
	self selectedSuborganization: self diagramOrganization.! !

!DiagramOrganizationBrowser methodsFor: 'updating' stamp: 'hpt 1/15/2003 19:58'!
updateDependencedDiagrams
	self removeDependencesOnDiagrams.
	self selectedSuborganization 
		ifNotNil:
			[self selectedSuborganizationDiagrams 
				do: [:ea | self addDependenceOnDiagram: ea]]! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 3/26/2003 20:19'!
organizationsListMenu: aMenu
	aMenu defaultTarget: self.
	self selectedSuborganization notNil
		ifTrue: [aMenu addTitle: 'Organization ', self selectedSuborganization name]
		ifFalse: [aMenu addTitle: 'Organizations'].
	self addSuborganizationMenuOptionsTo: aMenu.
	^aMenu.! !

!DiagramOrganizationBrowser methodsFor: 'morphic view' stamp: 'hpt 1/15/2003 20:23'!
hierarchicalListItemWrapper
	^Array with: (DiagramOrganizationListItemWrapper
		with: self diagramOrganization
		model: self).! !

!DiagramOrganizationBrowser methodsFor: 'submorphs-add/remove' stamp: 'hpt 1/15/2003 20:19'!
delete
	self removeDependencesOnDiagrams.! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 1/15/2003 20:00'!
moveSelectedDiagram
	(self menuOfAllOrganizationsWithTarget: self selector: #moveSelectedDiagramTo:)
		addTitle: 'select new suborganization?';
		popUpInWorld.! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 1/15/2003 20:00'!
moveSelectedSuborganization
	(self menuOfAllOrganizationsWithTarget: self selector: #moveSelectedSuborganizationTo:)
		addTitle: 'select new suborganization?';
		popUpInWorld.! !

!DiagramOrganizationBrowser methodsFor: 'morphic view' stamp: 'hpt 1/15/2003 19:50'!
preferredExtent
	^200@500! !

!DiagramOrganizationBrowser methodsFor: 'menu options' stamp: 'hpt 3/22/2003 16:55'!
addCopyOfDiagram
	| aTitle |
	aTitle _ FillInTheBlank request: 'Title?'
		initialAnswer: 'copy of ', self selectedDiagram title.
	aTitle isEmpty
		ifFalse: [self selectedSuborganization 
			addCopyOfDiagram: self selectedDiagram titled: aTitle].
	self changed: #selectedSuborganizationDiagramTitles.
! !

!DiagramOrganizationBrowser methodsFor: 'queries' stamp: 'hpt 1/15/2003 19:56'!
unselectSelectedDiagram
	self selectedDiagramIndex: 0.! !

!DiagramOrganizationBrowser methodsFor: 'addings/removals' stamp: 'hpt 1/15/2003 19:59'!
moveSelectedDiagramTo: anOrganization
	| diagram |
	diagram := self selectedDiagram.
	self removeSelectedDiagram.
	anOrganization addDiagram: diagram.
	self selectedSuborganization: anOrganization.
	self selectedDiagram: diagram.! !

Model subclass: #DiagramOrganization
	instanceVariableNames: 'name suborganizations diagrams'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiagramBrowser'!

!DiagramOrganization commentStamp: 'hpt 7/24/2004 14:16' prior: 0!
DiagramOrganization is a composite classification of Diagrams. !

!DiagramOrganization methodsFor: 'accessing' stamp: 'hpt 12/30/2002 13:50'!
name: aName
	name := aName.
! !

!DiagramOrganization methodsFor: 'accessing' stamp: 'hpt 12/30/2002 13:50'!
name
	^name
! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 3/26/2003 22:58'!
addSuborganizationFromFileNamed: aFileName to: anOrganization
	^anOrganization addSuborganizationFromFileNamed: aFileName.! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 12/31/2002 14:48'!
addSuborganization: anOrganization
	self suborganizations add: anOrganization.! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 12/31/2002 14:48'!
addDiagram: aDiagram
	self diagrams add: aDiagram.! !

!DiagramOrganization methodsFor: 'queries' stamp: 'hpt 12/30/2002 17:06'!
addAllSuborganizationsTo: aSet
	aSet addAll: self suborganizations.
	self suborganizations do: [:ea | ea addAllSuborganizationsTo: aSet].
	^aSet.
	! !

!DiagramOrganization class methodsFor: 'instance creation' stamp: 'hpt 3/27/2003 18:34'!
fromFileNamed: aFilename
	| stream anOrganization |
	stream := ReferenceStream fileNamed: aFilename.
	stream atEnd
		ifFalse: [Utilities 
			informUser: 'Reading diagram organization from ', aFilename 
			during: [anOrganization := stream next]].
	stream close.
	(anOrganization class ~= self)
		ifTrue: [self error: 'File don''t exist or don''t contain a Jacarand Organization'. ^nil].
	^anOrganization.! !

!DiagramOrganization class methodsFor: 'instance creation' stamp: 'hpt 3/22/2003 12:54'!
fromFile
	| aFilename anOrganization |
	aFilename := FillInTheBlank request: 'Diagram organization file name?'.
	aFilename isEmpty
		ifTrue: [^nil].
	anOrganization := self fromFileNamed: aFilename.
	anOrganization
		ifNil: [self inform: 'Invalid file or filename'].
	^anOrganization.! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 3/26/2003 22:52'!
chooseOrganizationAndAddSuborganizationFromFileNamed: aFileName
	| aMenu |
	aMenu _ self menuOfAllOrganizationsWithTarget: self 
		selector: #addSuborganizationFromFileNamed:to:
		arguments: { aFileName }.
	aMenu 
		addTitle: 'add new suborganization in...';
		popUpInWorld.! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 3/26/2003 22:33'!
addSuborganizationFromFile
	| anOrganization |
	anOrganization := DiagramOrganization fromFile.
	anOrganization ifNotNil: [self addSuborganization: anOrganization].
	^anOrganization.! !

!DiagramOrganization methodsFor: 'printing' stamp: 'hpt 12/30/2002 17:19'!
printString
	^self name, ' diagrams organization'.! !

!DiagramOrganization methodsFor: 'exporting' stamp: 'hpt 3/26/2003 20:50'!
saveToFile
	| fileName |
	fileName _ FileDirectory default 
		nextNameFor: self name extension: 'jo'.
	fileName _ FillInTheBlank 
		request: 'Diagram organization file name?' 
		initialAnswer: fileName.
	fileName notEmpty 
		ifTrue: [self saveToFileNamed: fileName].! !

DiagramOrganization subclass: #JacarandaRootOrganization
	instanceVariableNames: ''
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'DiagramBrowser'!

!JacarandaRootOrganization commentStamp: 'hpt 7/24/2004 14:29' prior: 0!
JacarandaRootOrganization is the DiagramOrganization singleton used by the DiagramBrowser as the root of its tree of categories.!

!JacarandaRootOrganization class methodsFor: 'class initialization' stamp: 'hpt 3/26/2003 23:10'!
serviceFileInJD
	^SimpleServiceEntry
		provider: self uniqueInstance
		label: 'install diagram'
		selector: #chooseOrganizationAndAddDiagramFromFileNamed: 
		description: 'install this diagram into the root Jacarand organization.'
		buttonLabel: 'install diagram'.! !

!JacarandaRootOrganization class methodsFor: 'instance creation' stamp: 'hpt 1/5/2003 17:05'!
new
	UniqueInstance 
		ifNotNil: [^nil] 
		ifNil: [^super new].! !

!JacarandaRootOrganization class methodsFor: 'class initialization' stamp: 'hpt 3/26/2003 22:16'!
services
	^Array with: self serviceFileInJD with: self serviceFileInJO.
! !

!JacarandaRootOrganization class methodsFor: 'class initialization' stamp: 'hpt 3/26/2003 22:17'!
fileReaderServicesForFile: fullName suffix: suffix 
	(suffix = 'jd')
		ifTrue: [^Array with: self serviceFileInJD].
	(suffix = 'jo')
		ifTrue: [^Array with: self serviceFileInJO].
	^#().
! !

!JacarandaRootOrganization class methodsFor: 'class initialization' stamp: 'hpt 3/26/2003 23:10'!
serviceFileInJO
	^SimpleServiceEntry
		provider: self uniqueInstance
		label: 'install diagram organization'
		selector: #chooseOrganizationAndAddSuborganizationFromFileNamed: 
		description: 'install this organization into the root Jacarand organization.'
		buttonLabel: 'install diagram organization'.! !

!JacarandaRootOrganization methodsFor: 'copying' stamp: 'hpt 3/12/2003 18:02'!
clone
	"a singleton must not be copied or it would'nt be a singleton. right?"
	self error: 'cloning a singleton instance?'.! !

!JacarandaRootOrganization class methodsFor: 'instance creation' stamp: 'hpt 1/5/2003 17:06'!
uniqueInstance
	UniqueInstance isNil
		ifTrue: [UniqueInstance := self named: 'Jacaranda'].
	^UniqueInstance.! !

!JacarandaRootOrganization class methodsFor: 'class initialization' stamp: 'hpt 3/26/2003 22:15'!
initialize
	super initialize.
	(FileList respondsTo: #registerFileReader:) 
		ifTrue: [ FileList registerFileReader: self ]! !

!JacarandaRootOrganization class methodsFor: 'initialize-release' stamp: 'hpt 3/26/2003 22:20'!
unload
	super unload.
	FileList unregisterFileReader: self ! !

!DiagramOrganization methodsFor: 'exporting' stamp: 'hpt 3/22/2003 17:04'!
saveToFileNamed: aFileName
	| stream |
	stream := ReferenceStream fileNamed: aFileName.
	Utilities informUser: 'Writing ', aFileName during: [stream nextPut: self].
	stream close.
! !

!DiagramOrganization methodsFor: 'accessing' stamp: 'hpt 12/30/2002 13:55'!
suborganizations
	^suborganizations! !

!DiagramOrganization class methodsFor: 'instance creation' stamp: 'hpt 12/30/2002 14:01'!
named: aName
	^(self new)
		name: aName;
		yourself! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 12/31/2002 10:28'!
removeDiagram: aDiagram
	self diagrams remove: aDiagram.
! !

!DiagramOrganization methodsFor: 'initialization' stamp: 'hpt 1/15/2003 20:15'!
initialize
	suborganizations := OrderedCollection new.
	diagrams := OrderedCollection new.
	name := 'unnamed (', self hash asString, ')'.
! !

!DiagramOrganization class methodsFor: 'test instances' stamp: 'hpt 12/31/2002 13:31'!
simpleTestInstance
	| rand n d o |
	o := DiagramOrganization new.
	rand := Random new.
	d := OrderedCollection new.
	n := rand nextInt: 3.
	n timesRepeat: [d add: Diagram new].
	o diagrams addAll: d.
	^o! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 3/26/2003 22:33'!
addSuborganizationFromFileNamed: aFileName
	| anOrganization |
	anOrganization := DiagramOrganization fromFileNamed: aFileName.
	anOrganization ifNotNil: [self addSuborganization: anOrganization].
	^anOrganization.! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 3/26/2003 22:58'!
addDiagramFromFileNamed: aFileName to: anOrganization
	^anOrganization addDiagramFromFileNamed: aFileName.! !

!DiagramOrganization class methodsFor: 'instance creation' stamp: 'hpt 12/30/2002 14:02'!
new
	^(super new)
		initialize;
		yourself.! !

!DiagramOrganization class methodsFor: 'test instances' stamp: 'hpt 12/31/2002 13:31'!
TwoLevelsComplexTestInstance
	| rand n d o |
	o := DiagramOrganization simpleTestInstance.
	rand := Random new.
	d := OrderedCollection new.
	n := rand nextInt: 5.
	n timesRepeat: [d add: DiagramOrganization complexTestInstance].
	o suborganizations addAll: d.
	^o name: 'Jacaranda'.! !

!DiagramOrganization methodsFor: 'accessing' stamp: 'hpt 12/30/2002 13:50'!
diagrams
	^diagrams! !

!DiagramOrganization methodsFor: 'menu options' stamp: 'hpt 3/26/2003 23:08'!
menuOfAllOrganizationsWithTarget: target selector: aSelector arguments: args
	| aMenu |
	(aMenu := MenuMorph new)
		add: '. (', self name, ')' 
		target: target
		selector: aSelector 
		argumentList: (args copyWith: self).
	self suborganizations do: [:ea |
		ea suborganizations isEmpty
			ifTrue: [
				aMenu 
					add: ea name 
					target: target
					selector: aSelector 
					argumentList: (args copyWith: ea)]
			ifFalse: [ | subMenu |
				subMenu _ (ea menuOfAllOrganizationsWithTarget: target 
						selector: aSelector arguments: args).
				subMenu firstSubmorph delete.
				aMenu 
					add: ea name 
					subMenu: subMenu
					target: target
					selector: aSelector
					argumentList: (args copyWith: ea)]].
	^aMenu.! !

!DiagramOrganization class methodsFor: 'test instances' stamp: 'hpt 12/31/2002 13:31'!
complexTestInstance
	| rand n d o |
	o := DiagramOrganization simpleTestInstance.
	rand := Random new.
	d := OrderedCollection new.
	n := rand nextInt: 3.
	n timesRepeat: [d add: DiagramOrganization simpleTestInstance].
	o suborganizations addAll: d.
	^o.! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 3/26/2003 22:50'!
chooseOrganizationAndAddDiagramFromFileNamed: aFileName
	| aMenu |
	aMenu _ self menuOfAllOrganizationsWithTarget: self 
		selector: #addDiagramFromFileNamed:to:
		arguments: { aFileName }.
	aMenu 
		addTitle: 'add new diagram in...';
		popUpInWorld.! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 12/31/2002 10:30'!
removeSuborganization: anOrganization
	self suborganizations remove: anOrganization
! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 3/12/2003 22:57'!
addCopyOfDiagram: aDiagram titled: aTitle
	self addDiagram: (aDiagram duplicate title: aTitle).! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 3/26/2003 22:32'!
addDiagramFromFileNamed: aFileName
	| aDiagram |
	aDiagram := Diagram fromFileNamed: aFileName.
	aDiagram ifNotNil: [self addDiagram: aDiagram].
	^aDiagram.! !

!DiagramOrganization methodsFor: 'queries' stamp: 'hpt 12/30/2002 21:14'!
parentOrganizationOf: suborganization
	| parents |
	parents := Set with: self.
	self addAllSuborganizationsTo: parents.
	^parents 
		detect: [:parent | parent suborganizations includes: suborganization] 
		ifNone: [nil].! !

!DiagramOrganization methodsFor: 'menu options' stamp: 'hpt 3/26/2003 22:56'!
menuOfAllOrganizationsWithTarget: target selector: aSelector
	^self menuOfAllOrganizationsWithTarget: target selector: aSelector arguments: #().! !

!DiagramOrganization methodsFor: 'addings/removals' stamp: 'hpt 3/26/2003 22:32'!
addDiagramFromFile
	| aDiagram |
	aDiagram := Diagram fromFile.
	aDiagram ifNotNil: [self addDiagram: aDiagram].
	^aDiagram.
! !

PasteUpMorph subclass: #HJPasteUpMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiagramBrowser'!

!HJPasteUpMorph commentStamp: 'hpt 7/24/2004 14:33' prior: 0!
HJPasteUpMorph is a customization of the vanilla PasteUpMorph so it will align the morphs that accepts on drop to the PasteUpMorph's grid.
!

!HJPasteUpMorph methodsFor: 'gridding' stamp: 'hpt 2/27/2003 18:09'!
snapMorphsOnDropToNearestGriddedPointOnOff
	self snapMorphsOnDropToNearestGriddedPoint:
		self snapMorphsOnDropToNearestGriddedPoint not.! !

!HJPasteUpMorph methodsFor: 'gridding' stamp: 'hpt 2/27/2003 18:09'!
snapMorphsOnDropToNearestGriddedPoint
	^self valueOfProperty: #snapMorphsOnDropToNearestGriddedPoint! !

!HJPasteUpMorph methodsFor: 'gridding' stamp: 'hpt 2/27/2003 18:09'!
snapMorphsOnDropToNearestGriddedPoint: trueOrFalse
	self setProperty: #snapMorphsOnDropToNearestGriddedPoint toValue: trueOrFalse.! !

!HJPasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'hpt 2/27/2003 18:10'!
acceptDroppingMorph: dropped event: evt
	super acceptDroppingMorph: dropped event: evt.
	self snapMorphsOnDropToNearestGriddedPoint
		ifTrue: [ dropped position: (dropped griddedPoint: dropped position)].! !

Morph subclass: #Diagram
	instanceVariableNames: 'title window annotations annotationsPanel canvas canvasScrollablePanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiagramBrowser'!

!Diagram commentStamp: 'hpt 7/24/2004 14:11' prior: 0!
Diagram is the part of the DiagramBrowser which holds the Morphic drawing. Its responsibility is to be the representation of a semantically cohesive grouping of Morphs.

Note that an instance of Diagram has a title, annotations and a canvas holding the drawing.

A drawing can be made of any kind of Morph. The canvas is a PasteUpMorph (an HJPasteUpMorph) which will accept the morphs upon drag'n drop.
!

!Diagram methodsFor: 'viewable area manipulation' stamp: 'hpt 3/24/2003 20:22'!
centerViewOnContents
	| contents rightmost leftmost topmost lowmost |
	contents _ self canvas submorphs.
	contents isEmpty ifTrue: [^self centerView].
	rightmost _ contents detectMax: [:ea | ea right].
	leftmost _ contents detectMin: [:ea | ea left].
	topmost _ contents detectMin: [:ea | ea top].
	lowmost _ contents detectMax: [:ea | ea bottom].
	self centerViewOnPoint: 
		(leftmost left@topmost top corner: rightmost right@lowmost bottom) center.! !

!Diagram methodsFor: 'zoom' stamp: 'hpt 3/24/2003 20:20'!
setScale: aNumber
	self transformMorph scale: ((aNumber max: 0.1) min: 100).
	Smalltalk garbageCollectMost.
	self centerViewOnContents.! !

!Diagram methodsFor: 'zoom' stamp: 'hpt 3/24/2003 19:09'!
transformMorph
	^self canvasScrollablePanel scroller! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/16/2002 09:40'!
newHideAndShowAnnotationsPanelButton
	^(PluggableButtonMorph 
		on: self
		getState: nil
		action: #switchAnnotationsPanelView
		label: #hideAndShowAnnotationsPanelButtonLabel)
			onColor: (self buttonsOnColor) offColor: (self buttonsOffColor);
			useRoundedCorners;
			yourself.! !

!Diagram methodsFor: 'accessing' stamp: 'hpt 12/15/2002 14:48'!
canvas
	^canvas! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/15/2002 17:43'!
newExportAsGIFButton
	^(PluggableButtonMorph 
		on: self
		getState: nil
		action: #exportAsGIF
		label: #exportAsGIFButtonLabel)
			onColor: (self buttonsOnColor) offColor: (self buttonsOffColor);
			useRoundedCorners;
			yourself.! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/16/2002 09:27'!
newAnnotationsPanel
	annotationsPanel := PluggableTextMorph 
		on: self 
		text: #annotations 
		accept: #annotations:.
	annotationsPanel
		color: (Color white);
		hResizing: #spaceFill;
		vResizing: #rigid;
		height: (self annotationsPanelHeight);
		yourself.
	^annotationsPanel.! !

!Diagram methodsFor: 'initialization' stamp: 'hpt 12/15/2002 17:25'!
preferredColor
	^ (Color r: 0.0 g: 0.462 b: 0.647)! !

!Diagram methodsFor: 'event handling' stamp: 'hpt 3/29/2003 18:42'!
mouseDown: evt
	super mouseDown: evt.
	evt yellowButtonPressed ifTrue: [self invokeMenu: evt].! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 12/30/2002 22:39'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If can respond, then perform it on myself.  If not, send it to otherTarget, presumably the editPane from which the menu was invoked." 

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!Diagram methodsFor: 'initialization' stamp: 'hpt 12/15/2002 18:33'!
openInWindow
	self extent: self preferredSize.
	window := super openInWindowLabeled: 'Diagram: ', self title.
	^window! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/15/2002 17:43'!
buttonsOffColor
	^(Color lightBlue).! !

!Diagram methodsFor: 'exporting' stamp: 'hpt 3/22/2003 17:23'!
exportAsGIF
	| fileName |
	fileName _ FileDirectory default 
		nextNameFor: self title extension: 'gif'.
	fileName _ FillInTheBlank request: 'GIF file name?' initialAnswer: fileName.
	fileName isEmpty ifTrue: [^self].
	self exportAsGIFToFileNamed: fileName! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/17/2002 19:41'!
newHideAndShowGridButton
	^(PluggableButtonMorph 
		on: self
		getState: nil
		action: #switchGrid
		label: #hideAndShowGridButtonLabel)
			onColor: (self buttonsOnColor) offColor: (self buttonsOffColor);
			useRoundedCorners;
			yourself.! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 3/26/2003 19:45'!
switchAnnotationsPanelPhrase
	^self annotationsPanelHidden
		ifTrue: ['show annotations panel']
		ifFalse: ['hide annotations panel'].! !

!Diagram class methodsFor: 'instance creation' stamp: 'hpt 3/22/2003 12:55'!
fromFile
	| aDiagram aFilename |
	aFilename := FillInTheBlank request: 'Diagram file name?'.
	aFilename isEmpty
		ifTrue: [^nil].
	aDiagram := self fromFileNamed: aFilename.
	aDiagram
		ifNil: [self inform: 'Invalid file or filename'].
	^aDiagram.! !

!Diagram class methodsFor: 'instance creation' stamp: 'hpt 3/27/2003 18:33'!
fromFileNamed: aFilename
	| stream aDiagram |
	stream := ReferenceStream fileNamed: aFilename.
	stream atEnd 
		ifFalse: [Utilities informUser: 'Reading diagram from ', aFilename during: [aDiagram := stream next]].
	stream close.
	(aDiagram class ~= self)
		ifTrue: [self error: 'File don''t exist or don''t contain a Jacarand Diagram'. ^nil].
	^aDiagram.! !

!Diagram methodsFor: 'viewable area manipulation' stamp: 'hpt 3/24/2003 20:11'!
centerViewOnPoint: aPoint
	| viewableArea |
	viewableArea _ Rectangle 
		center: (aPoint*self transformMorph scale) 
		extent: self canvasScrollablePanel scroller extent.
	self canvasScrollablePanel scrollIntoView:  viewableArea extra: 0.! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/16/2002 09:40'!
hideAndShowAnnotationsPanelButtonLabel
	^'switch annotations panel view'! !

!Diagram methodsFor: 'exporting' stamp: 'hpt 3/22/2003 12:29'!
printBounds
	| printBounds printableShapes |
	printableShapes _ self printableShapes.
	printBounds _ printableShapes first bounds.
	printableShapes do: [:ea | printBounds _ printBounds merge: ea bounds].
	^printBounds outsetBy: 10.! !

!Diagram methodsFor: 'annotations panel options' stamp: 'hpt 12/16/2002 09:54'!
annotationsPanelHidden
	^(self submorphs includes: self annotationsPanel) not.
! !

!Diagram methodsFor: 'accessing' stamp: 'hpt 12/16/2002 09:23'!
annotationsPanel
	^annotationsPanel! !

!Diagram methodsFor: 'initialization' stamp: 'hpt 12/16/2002 09:26'!
annotationsPanelHeight
	"Es un 10% del tamano de la ventana de diagrama"
	^(self preferredSize y / 10) asInteger.! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/15/2002 18:30'!
newChangeTitleButton
	^(PluggableButtonMorph 
		on: self
		getState: nil
		action: #changeTitle
		label: #changeTitleButtonLabel)
			onColor: (self buttonsOnColor) offColor: (self buttonsOffColor);
			useRoundedCorners;
			yourself.! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/15/2002 18:31'!
changeTitleButtonLabel
	^'change title'.! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/15/2002 17:43'!
buttonsOnColor
	^(self buttonsOffColor) alphaMixed: 0.7 with: (Color black).! !

!Diagram methodsFor: 'zoom' stamp: 'hpt 3/24/2003 19:09'!
smoothingOff
	self transformMorph smoothingOff! !

!Diagram methodsFor: 'exporting' stamp: 'hpt 3/22/2003 17:02'!
saveToFileNamed: aFileName
	| stream |
	stream := ReferenceStream fileNamed: aFileName.
	Utilities informUser: 'Writing ', aFileName during: [stream nextPut: self].
	stream close.
! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 12/15/2002 18:30'!
changeTitle
	| newTitle |
	newTitle := FillInTheBlank request: 'new title' initialAnswer: self title.
	newTitle isEmpty ifFalse: [self title: newTitle].! !

!Diagram methodsFor: 'initialization' stamp: 'hpt 12/31/2002 15:06'!
initialize
	super initialize.
	self 
		layoutPolicy: (TableLayout new);
		listDirection: #topToBottom;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: (Color white);
		title: 'untitled (', self hash asString, ')';
		newCanvasAndCanvasScrollablePanel;
		addMorphBack: (self canvasScrollablePanel);
		newAnnotationsPanel;
		centerView.! !

!Diagram methodsFor: 'zoom' stamp: 'hpt 3/24/2003 19:09'!
toggleSmoothing
	self transformMorph isSmoothingOn
		ifTrue: [self transformMorph smoothingOff]
		ifFalse: [self transformMorph smoothingOn]! !

!Diagram methodsFor: 'initialization' stamp: 'hpt 12/21/2002 12:43'!
preferredSize
	^500@500.! !

!Diagram methodsFor: 'accessing' stamp: 'hpt 12/15/2002 18:16'!
annotations
	^annotations! !

!Diagram methodsFor: 'accessing' stamp: 'hpt 12/15/2002 14:48'!
canvasScrollablePanel
	^canvasScrollablePanel.! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/17/2002 19:41'!
hideAndShowGridButtonLabel
	^'switch grid'! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/15/2002 17:44'!
exportAsGIFButtonLabel
	^'export as GIF'! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 2/27/2003 18:11'!
newCanvas
	canvas := (HJPasteUpMorph new)
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: (Color white);
		snapMorphsOnDropToNearestGriddedPoint: false;
		griddingOnOff;
		extent: 8000@8000.
	^canvas.! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 2/27/2003 18:11'!
switchGrid
	canvas gridVisibleOnOff.
	canvas snapMorphsOnDropToNearestGriddedPointOnOff.! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 3/26/2003 19:47'!
switchGridPhrase
	^self canvas gridVisible
		ifTrue: ['hide grid']
		ifFalse: ['show grid'].! !

!Diagram methodsFor: 'accessing' stamp: 'hpt 12/15/2002 14:49'!
canvas: aPasteUpMorph
	self canvasScrollablePanel scroller 
		removeAllMorphs;
		addMorphBack: aPasteUpMorph.
	canvas := aPasteUpMorph.
! !

!Diagram methodsFor: 'exporting' stamp: 'hpt 3/22/2003 12:08'!
printableShapes
	^self canvas submorphs select: [:ea | ea visible].
! !

!Diagram methodsFor: 'annotations panel options' stamp: 'hpt 12/31/2002 13:28'!
showAnnotationsPanel
	self addMorph: (self annotationsPanel) asElementNumber: 1.
! !

!Diagram methodsFor: 'zoom' stamp: 'hpt 3/24/2003 20:25'!
zoomIn
	self setScale: (2.0 min: self transformMorph scale  + 0.25).
	self transformMorph scale = 1
		ifTrue: [self smoothingOff]
		ifFalse: [self smoothingOn].
	! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 2/25/2003 21:36'!
newCanvasScrollablePanel
	canvasScrollablePanel := TwoWayScrollPane new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent.
	^canvasScrollablePanel.! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 3/26/2003 20:02'!
zoomOptionsMenu
	| aMenu |
	aMenu := MenuMorph new.
	aMenu
		add: 'zoom in'
		target: self
		selector: #zoomIn.
	aMenu
		add: 'remove zoom'
		target: self
		selector: #removeZoom.
	aMenu
		add: 'zoom out'
		target: self
		selector: #zoomOut.
	aMenu addStayUpItem.
	aMenu addTitle: 'zoom on ', self title, ' ...'.
	aMenu popUpInWorld.! !

!Diagram methodsFor: 'initialization' stamp: 'hpt 12/13/2002 19:05'!
openInWorld
	"if I invoke extent before the morph is in the world bad things happen. I don't know why"
	super openInWorld.
	self extent: self preferredSize.! !

!Diagram methodsFor: 'event handling' stamp: 'hpt 3/29/2003 18:42'!
handlesMouseDown: evt
	^evt yellowButtonPressed.! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 2/9/2003 22:50'!
invokeMenu: evt
	| menu |
	menu := MenuMorph new.
	menu addTitle: 'diagram ', self title.
	self addMenuOptionsTo: menu.
	menu popUpEvent: evt in: self world.! !

!Diagram methodsFor: 'zoom' stamp: 'hpt 3/24/2003 19:20'!
removeZoom
	self setScale: 1.
	self smoothingOff.	! !

!Diagram methodsFor: 'zoom' stamp: 'hpt 3/24/2003 19:09'!
smoothingOn
	self transformMorph smoothingOn! !

!Diagram methodsFor: 'viewable area manipulation' stamp: 'hpt 2/26/2003 20:30'!
centerViewOnArea: aRectangleArea
	| newViewableArea viewableAreaSize |
	viewableAreaSize _ self canvasScrollablePanel scroller extent.
	newViewableArea _ Rectangle center: aRectangleArea center extent: viewableAreaSize.
	self canvasScrollablePanel scrollIntoView: newViewableArea extra: 0.! !

!Diagram methodsFor: 'initialization' stamp: 'hpt 12/15/2002 17:23'!
openInWindowLabeled: aString inWorld: aWorld
	| window extent |
	window _ (SystemWindow labelled: aString) model: self.
	window setProperty: #paneColor toValue: self preferredColor.
	window 
		" guess at initial extent"
		bounds:  (RealEstateAgent initialFrameFor: window initialExtent: self fullBounds extent world: aWorld);
		addMorph: self frame: (0@0 extent: 1@1);
		updatePaneColors.
	" calculate extent after adding in case any size related attributes were changed.  Use
	fullBounds in order to trigger re-layout of layout morphs"
	extent _ self fullBounds extent + 
			(window borderWidth@window labelHeight) + window borderWidth.
	window extent: extent.
	aWorld addMorph: window.
	window activate.
	aWorld startSteppingSubmorphsOf: window.
	^window
! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/17/2002 19:41'!
newButtonsPanel
	| panel |
	panel := (Morph new)
		layoutPolicy: (TableLayout new);
		listDirection: #leftToRight;
		listCentering: #topLeft;
		cellInset: 10;
		layoutInset: 5;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		color: (self preferredColor).
	panel 
		addMorphBack: (self newChangeTitleButton);
		addMorphBack: (self newExportAsGIFButton);
		addMorphBack: (self newCenterViewButton);
		addMorphBack: (self newHideAndShowAnnotationsPanelButton);
		addMorphBack: (self newHideAndShowGridButton).
	^panel! !

!Diagram methodsFor: 'exporting' stamp: 'hpt 3/26/2003 20:49'!
saveToFile
	| fileName |
	fileName _ FileDirectory default 
		nextNameFor: self title extension: 'jd'.
	fileName _ FillInTheBlank request: 'Diagram file name?' initialAnswer: fileName.
	fileName notEmpty 
		ifTrue: [self saveToFileNamed: fileName].! !

!Diagram methodsFor: 'annotations panel options' stamp: 'hpt 12/16/2002 09:48'!
hideAnnotationsPanel
	self annotationsPanel delete.! !

!Diagram methodsFor: 'initialization' stamp: 'hpt 12/14/2002 20:02'!
openInHand
	"if I invoke extent before the morph is in the world bad things happen. I don't know why"
	super openInHand.
	self extent: self preferredSize.
! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 12/14/2002 20:07'!
dismiss
	self allOwners size > 1
		ifTrue: [self allOwners first dismiss]
		ifFalse: [self delete].! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 3/26/2003 20:02'!
centerViewOptionsMenu
	| menu |
	menu := MenuMorph new.
	menu defaultTarget: self.	
	menu addStayUpItem.
	menu addTitle: 'center view on ', self title, ' ...'.
	menu add: 'on contents' action: #centerViewOnContents.
	menu add: 'on center' action: #centerView.
	menu popUpInWorld.! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/15/2002 17:51'!
newCenterViewButton
	^(PluggableButtonMorph 
		on: self
		getState: nil
		action: #centerViewOptionsMenu
		label: #centerViewButtonLabel)
			onColor: (self buttonsOnColor) offColor: (self buttonsOffColor);
			useRoundedCorners;
			yourself.! !

!Diagram methodsFor: 'zoom' stamp: 'hpt 3/24/2003 20:25'!
zoomOut
	self setScale: (0.25 max: (self transformMorph scale - 0.25)).
	self transformMorph scale = 1
		ifTrue: [self smoothingOff]
		ifFalse: [self smoothingOn].
	! !

!Diagram methodsFor: 'accessing' stamp: 'hpt 12/15/2002 18:16'!
title
	^title! !

!Diagram methodsFor: 'exporting' stamp: 'hpt 3/22/2003 17:23'!
exportAsGIFToFileNamed: aFileName
	Utilities informUser: 'Writing ', aFileName
		during: [GIFReadWriter putForm: self printCanvasForm form onFileNamed: aFileName].! !

!Diagram methodsFor: 'viewable area manipulation' stamp: 'hpt 2/26/2003 20:32'!
canvasCenterViewableArea
	^Rectangle center: self canvas center extent: self canvasScrollablePanel scroller extent! !

!Diagram methodsFor: 'annotations panel options' stamp: 'hpt 12/16/2002 09:41'!
switchAnnotationsPanelView
	self annotationsPanelHidden ifTrue: [self showAnnotationsPanel]
		ifFalse: [self hideAnnotationsPanel].! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/15/2002 14:46'!
newCanvasAndCanvasScrollablePanel
	self newCanvasScrollablePanel.
	self newCanvas.
	self newCanvasScrollablePanel scroller addMorphBack: self canvas.! !

!Diagram methodsFor: 'submorphs - private' stamp: 'hpt 12/15/2002 17:47'!
centerViewButtonLabel
	^'center view...'! !

!Diagram methodsFor: 'accessing' stamp: 'hpt 12/31/2002 14:25'!
annotations: aString
	annotations := aString.
	self changed: #annotations.! !

!Diagram methodsFor: 'menu options' stamp: 'hpt 3/26/2003 20:01'!
addMenuOptionsTo: aMenu
	aMenu
		add: 'file-out'
		target: self
		selector: #saveToFile.
	aMenu
		add: 'export as GIF'
		target: self
		selector: #exportAsGIF.
	aMenu
		add: 'change title'
		target: self
		selector: #changeTitle.
	aMenu
		addUpdating: #switchAnnotationsPanelPhrase
		target: self
		action: #switchAnnotationsPanelView.
	aMenu
		addUpdating: #switchGridPhrase
		target: self
		action: #switchGrid.
	aMenu
		add: 'center view...'
		target: self
		action: #centerViewOptionsMenu.
	aMenu
		add: 'zoom...'
		target: self
		action: #zoomOptionsMenu.
	aMenu addStayUpItem.
	^aMenu.! !

!Diagram methodsFor: 'events-processing' stamp: 'hpt 2/9/2003 22:48'!
mouseDownPriority
	"I wan't to capture the mouseDown event before the canvas and it's pane"
	^(canvas mouseDownPriority max: canvasScrollablePanel mouseDownPriority) +1.! !

!Diagram methodsFor: 'exporting' stamp: 'hpt 3/22/2003 12:45'!
printCanvasForm
	| canvasForm printBounds |
	printBounds _ self printBounds.
	canvasForm _ FormCanvas extent: printBounds extent depth: 8.
	canvasForm 
		setOrigin: printBounds origin negated clipRect: (0@0 extent: printBounds extent).
	canvasForm fillColor: self canvas color.
	self printableShapes reverseDo: [:ea | ea fullDrawOn: canvasForm].
	^canvasForm.! !

!Diagram methodsFor: 'accessing' stamp: 'hpt 12/31/2002 14:25'!
title: aString
	title := aString.
	window ifNotNil: [window setLabel: 'Diagram: ', title].
	self changed: #title.! !

!Diagram methodsFor: 'viewable area manipulation' stamp: 'hpt 2/26/2003 20:39'!
centerView
	self centerViewOnPoint: self canvas center.! !

Morph subclass: #RepelDropsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiagramBrowser'!

!RepelDropsMorph commentStamp: 'hpt 7/24/2004 14:32' prior: 0!
RepelDropsMorph its just the morph that is used by the DiagramBrowser when there is no Diagram selected. The only thing that this morph does is repel the morphs dropping on an empty DiagramBrowser window.!

!RepelDropsMorph methodsFor: 'dropping/grabbing' stamp: 'hpt 4/12/2003 17:16'!
repelsMorph: m event: e
	^true.! !

!RepelDropsMorph methodsFor: 'event handling' stamp: 'hpt 4/12/2003 17:41'!
handlesMouseDown: anEvent
	^true.! !

Object subclass: #DiagramBrowser
	instanceVariableNames: 'diagramOrganizationBrowser diagramPane currentDiagram browserWindow noDiagramSelectedSign'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiagramBrowser'!

!DiagramBrowser commentStamp: '<historical>' prior: 0!
DiagramBrowser is a tool for building and browsing diagrams organized in a tree of categories.

The main components of DiagramBrowser are: Diagram, DiagramOrganization and DiagramOrganizationBrowser. See their respective class comments for more detailed info.

Note that DiagramBrowser can be used by its own and its delivered in a separate package but its part of the Jacarand Project. For more detailed info on Jacarand see its Squeakmap page.
!

!DiagramBrowser methodsFor: 'accessing' stamp: 'hpt 4/12/2003 17:21'!
currentDiagram: aDiagramOrNil
	currentDiagram := aDiagramOrNil.
	diagramPane removeAllMorphs.
	aDiagramOrNil 
		ifNil: [diagramPane addMorph: noDiagramSelectedSign]
		ifNotNil: [diagramPane addMorph: aDiagramOrNil].
	self changed: #relabel.! !

!DiagramBrowser methodsFor: 'initialization' stamp: 'hpt 4/12/2003 17:20'!
initialize
	| aDiagramOrganizationBrowser |
	aDiagramOrganizationBrowser := DiagramOrganizationBrowser new.
	self 
		initializeNoDiagramSelectedSign;
		initializeCurrentAndDiagramPane;
		diagramOrganizationBrowser: aDiagramOrganizationBrowser.
! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 12/31/2002 13:58'!
defaultBrowserTitle
	^'Diagram Browser'.! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 1/15/2003 20:37'!
buildOrganizationsListPane
	^self diagramOrganizationBrowser newOrganizationsList! !

!DiagramBrowser class methodsFor: 'registration' stamp: 'hpt 7/25/2004 15:37'!
addToOpenMenu
	TheWorldMenu registerOpenCommand: {'Diagram Browser'. {self. #openBrowser}}.! !

!DiagramBrowser methodsFor: 'accessing' stamp: 'hpt 1/15/2003 22:11'!
diagramOrganizationBrowser: anOrganizationBrowser
	diagramOrganizationBrowser 
		ifNotNil: [diagramOrganizationBrowser removeDependent: self].
	diagramOrganizationBrowser := anOrganizationBrowser.
	diagramOrganizationBrowser addDependent: self.
	diagramOrganizationBrowser unselectSelectedSuborganization.
	diagramOrganizationBrowser unselectSelectedDiagram.! !

!DiagramBrowser class methodsFor: 'instance creation' stamp: 'hpt 12/31/2002 10:39'!
new
	^(super new)
		initialize;
		yourself.! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 12/31/2002 13:58'!
labelString
	self currentDiagram 
		ifNotNil: [^'Diagram Browser: ', self currentDiagram title]
		ifNil: [^'Diagram Browser'].! !

!DiagramBrowser methodsFor: 'initialization' stamp: 'hpt 4/12/2003 17:20'!
initializeCurrentAndDiagramPane
	diagramPane := (Morph new)
		color: (Color white);
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutPolicy: (TableLayout new);
		listDirection: #topToBottom;
		addMorph: noDiagramSelectedSign;
		yourself.
	currentDiagram := nil.! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 12/31/2002 11:58'!
organizationsListFrame
	^(0@0 corner: 0.25@0.4).! !

!DiagramBrowser class methodsFor: 'registration' stamp: 'hpt 7/25/2004 15:44'!
unload
	self removeFromOpenMenu; removeFromToolsFlap! !

!DiagramBrowser methodsFor: 'accessing' stamp: 'hpt 12/31/2002 11:51'!
currentDiagram
	^currentDiagram! !

!DiagramBrowser class methodsFor: 'registration' stamp: 'hpt 7/25/2004 15:50'!
removeFromOpenMenu
	TheWorldMenu unregisterOpenCommandWithReceiver: self.! !

!DiagramBrowser methodsFor: 'accessing' stamp: 'hpt 12/31/2002 13:08'!
diagramPane
	^diagramPane! !

!DiagramBrowser class methodsFor: 'registration' stamp: 'hpt 7/25/2004 15:42'!
toolsFlapQuad
	^#(DiagramBrowser prototypicalToolWindow 'Diagram Browser' 'Opens a DiagramBrowser window')! !

!DiagramBrowser class methodsFor: 'registration' stamp: 'hpt 7/25/2004 15:48'!
addToToolsFlap
	"temporarily disabled until a bug with the regeneration of the Tools Flap is fixed
	
	Flaps registerQuad: self toolsFlapQuad forFlapNamed: 'Tools' translated.
	Flaps replaceToolsFlap."! !

!DiagramBrowser methodsFor: 'initialization' stamp: 'hpt 4/12/2003 17:40'!
initializeNoDiagramSelectedSign
	(noDiagramSelectedSign _ RepelDropsMorph new)
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!DiagramBrowser methodsFor: 'accessing' stamp: 'hpt 1/15/2003 20:36'!
diagramOrganizationBrowser
	^diagramOrganizationBrowser! !

!DiagramBrowser methodsFor: 'updating' stamp: 'hpt 1/15/2003 20:40'!
updateSelectedDiagram
	self currentDiagram: (self diagramOrganizationBrowser selectedDiagram).! !

!DiagramBrowser class methodsFor: 'instance creation' stamp: 'hpt 1/5/2003 17:50'!
prototypicalToolWindow
	| browserModel |
	browserModel := self new.
	^(browserModel asMorph)
		setLabel: browserModel defaultBrowserTitle;
		applyModelExtent.! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 1/5/2003 16:59'!
defaultDiagramOrganization
	^JacarandaRootOrganization uniqueInstance.! !

!DiagramBrowser class methodsFor: 'registration' stamp: 'hpt 7/25/2004 15:42'!
removeFromToolsFlap
	Flaps unregisterQuad: self toolsFlapQuad forFlapNamed: 'Tools' translated.
	Flaps replaceToolsFlap.! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 12/31/2002 13:54'!
preferredColor
	^ (Color r: 0.0 g: 0.462 b: 0.647) lighter! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 12/31/2002 11:58'!
diagramsListFrame
	^(0@0.4 corner: 0.25@1).! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 4/12/2003 17:40'!
asMorph
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	browserWindow := (SystemWindow labelled: 'later') 
		model: self;
		setWindowColor: self preferredColor;
		yourself.
	browserWindow
		addMorph: self buildOrganizationsListPane
		frame: self organizationsListFrame.
	browserWindow
		addMorph: self buildDiagramsListPane
		frame: self diagramsListFrame.
	browserWindow
		addMorph: self diagramPane
		frame: self diagramPaneFrame.
	^browserWindow.! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 1/15/2003 20:37'!
buildDiagramsListPane
	^self diagramOrganizationBrowser newDiagramsList.! !

!DiagramBrowser class methodsFor: 'instance creation' stamp: 'hpt 1/5/2003 16:55'!
openBrowser
	| browserModel |
	browserModel := self new.
	(browserModel asMorph)
		setLabel: browserModel defaultBrowserTitle;
		openInWorld.
	^browserModel.! !

!DiagramBrowser methodsFor: 'initialize-release' stamp: 'hpt 12/31/2002 11:57'!
diagramPaneFrame
	^(0.25@0 corner: 1@1).! !

!DiagramBrowser class methodsFor: 'registration' stamp: 'hpt 7/25/2004 15:44'!
initialize
	self addToOpenMenu; addToToolsFlap.! !

!DiagramBrowser methodsFor: 'updating' stamp: 'hpt 12/31/2002 11:35'!
update: aSymbol
	aSymbol == #selectedDiagram
		ifTrue: [self updateSelectedDiagram]! !

ListItemWrapper subclass: #DiagramOrganizationListItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiagramBrowser'!

!DiagramOrganizationListItemWrapper commentStamp: 'hpt 7/24/2004 14:36' prior: 0!
This is the ListItemWrapper required for the SimpleHierarchicalListMorph of DiagramOrganizations.
!

!DiagramOrganizationListItemWrapper methodsFor: 'as yet unclassified' stamp: 'hpt 12/30/2002 15:05'!
hasContents
	^item suborganizations isEmpty not! !

!DiagramOrganizationListItemWrapper methodsFor: 'as yet unclassified' stamp: 'hpt 12/27/2002 12:46'!
asString
	^item name! !

!DiagramOrganizationListItemWrapper methodsFor: 'as yet unclassified' stamp: 'hpt 1/15/2003 20:24'!
contents
	^item suborganizations collect: 
		[:ea | DiagramOrganizationListItemWrapper with: ea model: model].! !
JacarandaRootOrganization initialize!
DiagramBrowser initialize!
